d("cartOrderReviewView",['util','datepicker'], function(util ,datepicker) {

    return {
        extendCartOrderReviewView: function(orderReviewView) {

            var autocomplete;
            bindPaymentMethod();

            //Initiliaze Controller Method
            var javascriptLibrary = 'orderReview';//API JS
            var apexClassName= 'OXB2B_CheckoutController';
            var apexMethods = ['retrieveAddressData','retrieveCheckoutConfigInfo'];

            //Initializing JS Remoting Library from Apex Class
            util.initializeVisualforceRemoting(javascriptLibrary , apexClassName ,  apexMethods);

            let reqData ={};
            if(CCRZ.cartCheckoutModel.attributes.account){
                reqData.accountid  = CCRZ.cartCheckoutModel.attributes.effectiveAccountID;
            }

            CCRZ.subsc.orderReview.retrieveCheckoutConfigInfo(JSON.stringify(reqData) , populateCheckoutData);

            $( "#SubmitOrder" ).on('click',function() {
                initCheckOut();
            });

            $( "#updateShippingAddressValues" ).on('click',function() {
                updateShippingAddressValues();
            });

            $( "#termsConditionsCheckbox" ).on('click',function() {
                //$('#termsWarning').hide();
            });

            const options = {
                componentRestrictions: { country: ["us","ca"]},
                fields: ["address_components", "geometry", "icon", "name"],
                strictBounds: false,
                types: ["geocode"],
            };
            const input = document.getElementById("add_Address1");
            autocomplete = new google.maps.places.Autocomplete(input, options);
            autocomplete.addListener('place_changed',onPlaceChanged);

            function onPlaceChanged(){

                var place = autocomplete.getPlace();
                let address1 = "";
                let postcode = "";
                let city = '';
                let country = '';
                let stateProvince = '';
                // Get each component of the address from the place details,
                // and then fill-in the corresponding field on the form.
                // place.address_components are google.maps.GeocoderAddressComponent objects
                // which are documented at http://goo.gle/3l5i5Mr
                for (const component of place.address_components) {
                    const componentType = component.types[0];
                    switch (componentType) {
                        case "street_number": {
                            address1 = `${component.long_name} ${address1}`;
                            break;
                        }
                        case "route": {
                            address1 += component.short_name;
                            break;
                        }
                        case "postal_code": {
                            postcode = `${component.long_name}${postcode}`;
                            break;
                        }
                        case "postal_code_suffix": {
                            postcode = `${postcode}-${component.long_name}`;
                            break;
                        }
                        case "locality":
                            city = component.long_name;
                            break;
                        case "administrative_area_level_1": {
                            stateProvince = component.short_name;
                            break;
                        }
                        case "country":
                            country = component.short_name;
                            break;
                    }
                }

                document.getElementById("add_Address1").value = address1;
                if(country.toUpperCase()=='USA' || country.toUpperCase() =='US') {
                    country='US';
                    //postcode = postcode.substring(0, 5);
                }
                else{
                    country='CA';
                }
                var el = document.getElementById('countrySectionShip');
                el.value=country.toUpperCase();
                el.dispatchEvent(new Event('change'));
                document.getElementById("stateSectionShip").value =stateProvince.toUpperCase();
                document.getElementById("add_City").value = city;
                document.getElementById("add_PostalCode").value = postcode;
            }
        },
    }

    function populateCheckoutData(resp ,event)
    {
        let shippingMethodOptionArray = [];
        if(resp && resp.data ){
            if (resp.data.addressBook) {
                for (let index = 0; index < resp.data.addressBook.length; index++) {
                    const firstName = resp.data.addressBook[index].ccrz__E_ContactAddress__r.ccrz__FirstName__c;
                    const lastName = resp.data.addressBook[index].ccrz__E_ContactAddress__r.ccrz__LastName__c;
                    const companyName = resp.data.addressBook[index].ccrz__E_ContactAddress__r.ccrz__CompanyName__c;
                    const addressFirstline = resp.data.addressBook[index].ccrz__E_ContactAddress__r.ccrz__AddressFirstline__c;
                    const addressSecondline = resp.data.addressBook[index].ccrz__E_ContactAddress__r.ccrz__AddressSecondline__c;
                    const city = resp.data.addressBook[index].ccrz__E_ContactAddress__r.ccrz__City__c;
                    const state = resp.data.addressBook[index].ccrz__E_ContactAddress__r.ccrz__State__c;
                    const postalCode = resp.data.addressBook[index].ccrz__E_ContactAddress__r.ccrz__PostalCode__c;
                    const country = resp.data.addressBook[index].ccrz__E_ContactAddress__r.ccrz__Country__c;
                    const Id = resp.data.addressBook[index].Id;
                    const shipToRef = resp.data.addressBook[index].ccrz__E_ContactAddress__r.OXB2B_Oxbox_Locations__c;
                    var array ={firstName:firstName, lastName:lastName, companyName:companyName, addressFirstline:addressFirstline, addressSecondline:addressSecondline, city:city , state:state, postalCode:postalCode, country:country, Id:Id, shipToRef:shipToRef};

                    mapForShippSelect.set(Id, array);

                    var shippaddress = ' <div class="row cc_billing_shipping_info">';
                    shippaddress+= '<div class="col-md-9 cc_personal_info">';
                    if(companyName != "" && companyName != undefined) {
                        shippaddress += '<br>'+ companyName;
                    }
                    shippaddress+= '<br>'+ firstName +' ' +lastName + '<br>' +addressFirstline;
                    if(addressSecondline != "" && addressSecondline != undefined) {
                        shippaddress += '<br>'+ addressSecondline;
                    }
                    shippaddress+= '<br>'+city+', '+ state + ' ' +postalCode+'<br>'+country;
                    shippaddress+= ' </div>';

                    shippaddress+= '<div class="col-md-3 cc_select selctBtn" style="margin-top: 8%;">';
                    shippaddress+= '<div>';

                    shippaddress+='<button onClick="selectShipAdd()" class="btn btn-default btn-sm" id=\"'+Id+'\">Select</button></div>';

                    shippaddress+= '</div></div></div>';

                    $(".selectShipAdd").append(shippaddress);

                }
                //Shipping
                CCRZ.cartCheckoutModel.attributes.shippingAddress.firstName = resp.data.addressBook[0].ccrz__E_ContactAddress__r.ccrz__FirstName__c;
                CCRZ.cartCheckoutModel.attributes.shippingAddress.lastName = resp.data.addressBook[0].ccrz__E_ContactAddress__r.ccrz__LastName__c;
                CCRZ.cartCheckoutModel.attributes.shippingAddress.companyName = resp.data.addressBook[0].ccrz__E_ContactAddress__r.ccrz__CompanyName__c;
                CCRZ.cartCheckoutModel.attributes.shippingAddress.addressFirstline = resp.data.addressBook[0].ccrz__E_ContactAddress__r.ccrz__AddressFirstline__c;;
                CCRZ.cartCheckoutModel.attributes.shippingAddress.addressSecondline = resp.data.addressBook[0].ccrz__E_ContactAddress__r.ccrz__AddressSecondline__c;;
                CCRZ.cartCheckoutModel.attributes.shippingAddress.city = resp.data.addressBook[0].ccrz__E_ContactAddress__r.ccrz__City__c;
                CCRZ.cartCheckoutModel.attributes.shippingAddress.state = resp.data.addressBook[0].ccrz__E_ContactAddress__r.ccrz__State__c;
                CCRZ.cartCheckoutModel.attributes.shippingAddress.postalCode = resp.data.addressBook[0].ccrz__E_ContactAddress__r.ccrz__PostalCode__c;
                CCRZ.cartCheckoutModel.attributes.shippingAddress.country = resp.data.addressBook[0].ccrz__E_ContactAddress__r.ccrz__Country__c;
                CCRZ.cartCheckoutModel.attributes.shippingAddress.shipToRef = resp.data.addressBook[0].ccrz__E_ContactAddress__r.OXB2B_Oxbox_Locations__c;

                var shipAdd = "";
                if(CCRZ.cartCheckoutModel.attributes.shippingAddress.companyName != "" && CCRZ.cartCheckoutModel.attributes.shippingAddress.companyName != undefined) {
                    shipAdd = "<br>" + CCRZ.cartCheckoutModel.attributes.shippingAddress.companyName;
                }
                shipAdd += "<br>" + CCRZ.cartCheckoutModel.attributes.shippingAddress.firstName + " " + CCRZ.cartCheckoutModel.attributes.shippingAddress.lastName + "<br>" + CCRZ.cartCheckoutModel.attributes.shippingAddress.addressFirstline;
                if(CCRZ.cartCheckoutModel.attributes.shippingAddress.addressSecondline != "" && CCRZ.cartCheckoutModel.attributes.shippingAddress.addressSecondline != undefined) {
                    shipAdd += "<br>" + CCRZ.cartCheckoutModel.attributes.shippingAddress.addressSecondline;
                }
                shipAdd += "<br>" + CCRZ.cartCheckoutModel.attributes.shippingAddress.city + ", " + CCRZ.cartCheckoutModel.attributes.shippingAddress.state + " " + CCRZ.cartCheckoutModel.attributes.shippingAddress.postalCode + "<br>" + CCRZ.cartCheckoutModel.attributes.shippingAddress.country;
                $(".cc_shipping_address").html(shipAdd);

            }

            if(resp.data.billToAddress){
                CCRZ.cartCheckoutModel.attributes.billingAddress.firstName = CCRZ.cartCheckoutModel.attributes.buyerFirstName;;
                CCRZ.cartCheckoutModel.attributes.billingAddress.lastName = CCRZ.cartCheckoutModel.attributes.buyerLastName;
                CCRZ.cartCheckoutModel.attributes.billingAddress.addressFirstline = resp.data.billToAddress.BillingStreet;
                CCRZ.cartCheckoutModel.attributes.billingAddress.city = resp.data.billToAddress.BillingCity;
                CCRZ.cartCheckoutModel.attributes.billingAddress.state = resp.data.billToAddress.BillingState;
                CCRZ.cartCheckoutModel.attributes.billingAddress.postalCode = resp.data.billToAddress.BillingPostalCode;
                CCRZ.cartCheckoutModel.attributes.billingAddress.country = resp.data.billToAddress.BillingCountry;
                $(".cc_billing_address").html("<br>" + CCRZ.cartCheckoutModel.attributes.billingAddress.addressFirstline + "<br>" + CCRZ.cartCheckoutModel.attributes.billingAddress.city + ", " + CCRZ.cartCheckoutModel.attributes.billingAddress.state + " " + CCRZ.cartCheckoutModel.attributes.billingAddress.postalCode + "<br>" + CCRZ.cartCheckoutModel.attributes.billingAddress.country);
            }

            if(!resp.data.shippingmethod){
                CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM',
                            severity : 'ERROR',
                            message : 'Error in retrieving shipping methods.',
                            classToAppend : 'messagingSection-Warning'
                        }
                    ]
                });
            }
            let COPurchaseOrderNumberElement = document.getElementById('COPurchaseOrderNumber');
            COPurchaseOrderNumberElement.addEventListener("change", function () {
                $('.messagingSection-Error').hide();
            });
            let RequestShipdateElement = document.getElementById('RequestShipdate'); 
            RequestShipdateElement.addEventListener("change", function () {
                $('.messagingSection-Error').hide();
            });
            if(resp.data.warehouse){

                let uniqueWarehouseValues = [];
                let selectList = document.getElementById('COwarehouse');
                let newOption = document.createElement("option");
                newOption.text = 'Please select a priority';
                newOption.value = '';
                newOption.selected = true;
                selectList.appendChild(newOption);
                for (let i = 0; i < resp.data.warehouse.length; i++) {
                    let newOption = document.createElement("option");
                    newOption.text = resp.data.warehouse[i].MasterLabel;
                    newOption.value = resp.data.warehouse[i].Oracle_Code__c;
                    selectList.appendChild(newOption);
                }

                let genericShippingMethodStdOptions = [];
                let genericShippingMethodExpeditedOptions = [];

                for (let i = 0; i < resp.data.shippingmethod.length; i++) {
                    var label = resp.data.shippingmethod[i].MasterLabel;
                    var oracleVal = resp.data.shippingmethod[i].Oracle_Code__c
                        let newOption = document.createElement("option");
                        newOption.text = label;
                        newOption.value = oracleVal;

                        if (label==='N/A') {
                            genericShippingMethodStdOptions.push(newOption);
                        }
                        else {
                            genericShippingMethodExpeditedOptions.push(newOption);

                        }
                }

                let COshippingmethodElement = document.getElementById('COshippingmethod');

                COshippingmethodElement.addEventListener("change", function () {
                    let COshippingmethodvalue = $('#COshippingmethod  option:selected').text();  
                    let COwarehousevalue = $('#COwarehouse  option:selected').text();  
                       //$('#COshippingmethod').val();
                    if(COshippingmethodvalue){
                            if(COshippingmethodvalue.includes("Air")){
                                $(".ShipingmethodMsg").html("Please note that air will be come with an increased cost");
                                            $(".ShipingmethodMsg").css("display","block");

                                $(".liftGateSection").css("display", "none");
                                document.getElementById("Lift Get Required").checked = false;
                                $('#ShippingRequirementsMsg').hide();
                                if(COwarehousevalue==='Emergency'){
                                    $('#emgncyShippingPriorityDiv').css('display','block');
                                    $('#termsEmgncyShipPriorityCheckbox').prop('checked', false);
                                }
                            }
                            else if('LTL' === COshippingmethodvalue){
                                $(".ShipingmethodMsg").html("Please note LTL may increase likelihood of damage");
                                            $(".ShipingmethodMsg").css("display","block");
                                $(".liftGateSection").css("display", "block");
                                if(COwarehousevalue==='Emergency'){
                                    $('#emgncyShippingPriorityDiv').css('display','block');
                                    $('#termsEmgncyShipPriorityCheckbox').prop('checked', false);
                                }


                            }
                            else if('Will Call' === COshippingmethodvalue){
                                $(".ShipingmethodMsg").html("Please note will call orders require 4 hours advance notice");
                                            $(".ShipingmethodMsg").css("display","block");

                                $(".liftGateSection").css("display", "none");
                                document.getElementById("Lift Get Required").checked = false;
                                $('#ShippingRequirementsMsg').hide();
                                $('#emgncyShippingPriorityDiv').css('display','none');

                            }

                            else{
                                $(".ShipingmethodMsg").html("");
                                $(".ShipingmethodMsg").css("display","none");

                                $(".liftGateSection").css("display", "none");
                                document.getElementById("Lift Get Required").checked = false;
                                $('#ShippingRequirementsMsg').hide();
                                $('#emgncyShippingPriorityDiv').css('display','none');

                            }
                        }
                });

                let warehouseElement = document.getElementById('COwarehouse');

                warehouseElement.addEventListener("change", function () {
                    $('.messagingSection-Error').hide();
                    let warehousevalue = $('#COwarehouse').val();
                    let shippingMethodElement = document.getElementById('COshippingmethod');
                    shippingMethodElement.length = 0;
                    if(warehousevalue){
                        let selectList = document.getElementById('COshippingmethod');
                        $('#RequestShipdate').val('') ;
                            if('Standard Priority' === warehousevalue){
                                /** Setting up shipping methods */
                                $(".ShipingmethodMsg").html("");
                                $(".ShipingmethodMsg").css("display","none");
                                $(".StandardShipingmethodMsg").css("display","block");
                                $(".StandardShipingmethodMsg").html("Default lead time for standard shipping is 2 weeks. Product may ship sooner or later than that depending on shipment size and availability");
                                $(".liftGateSection").css("display", "none");
                                document.getElementById("Lift Get Required").checked = false;
                                $('#ShippingRequirementsMsg').hide();
                                shippingMethodElement.appendChild(genericShippingMethodStdOptions[0]);
                                /** Setting up Request Ship Date */
                                const date = new Date();
                                let newShippingDate = new Date(date.setDate(date.getDate() + 15));
                                let day = String(newShippingDate.getDate()).padStart(2, "0");
                                let month = String(newShippingDate.getMonth()+1).padStart(2, "0");
                                let year = newShippingDate.getFullYear();
                                let fullDate = year+'-'+month+'-'+day;
                                $('#RequestShipdate').attr('min', fullDate) ;
                                $('#emgncyShippingPriorityDiv').css('display','none');
                            }else {
                                $(".StandardShipingmethodMsg").css("display","none");
                                $(".StandardShipingmethodMsg").html("");
                                let date = new Date();
                                let day = String(date.getDate()).padStart(2, "0");
                                let month = String(date.getMonth()+1).padStart(2, "0");
                                let year = date.getFullYear();
                                let fullDate = year+'-'+month+'-'+day;
                                $('#RequestShipdate').attr('min', fullDate) ;
                                for(let i = 0; i < genericShippingMethodExpeditedOptions.length; i++) {
                                    shippingMethodElement.appendChild(genericShippingMethodExpeditedOptions[i]);
                                }
                                let COshippingmethodvalue = $('#COshippingmethod option:selected').text(); //$('#COshippingmethod').val();
                                //if('Air – Next Date' === COshippingmethodvalue){
                                if(COshippingmethodvalue.includes("Air")){
                                    $(".ShipingmethodMsg").html("Please note that air will be come with an increased cost");
                                    $(".ShipingmethodMsg").css("display","block");

                                    $(".liftGateSection").css("display", "none");
                                    document.getElementById("Lift Get Required").checked = false;
                                    $('#ShippingRequirementsMsg').hide();
                                    $('#emgncyShippingPriorityDiv').css('display','block');
                                    $('#termsEmgncyShipPriorityCheckbox').prop('checked', false);
                                }

                                else if('LTL' === COshippingmethodvalue){
                                    $(".ShipingmethodMsg").html("Please note LTL may increase likelihood of damage");
                                    $(".ShipingmethodMsg").css("display","block");

                                    $(".liftGateSection").css("display", "block");
                                    $('#emgncyShippingPriorityDiv').css('display','block');
                                    $('#termsEmgncyShipPriorityCheckbox').prop('checked', false);
                                }
                                else if('Will Call' === COshippingmethodvalue){
                                    $(".ShipingmethodMsg").html("Please note will call orders require 4 hours advance notice");
                                    $(".ShipingmethodMsg").css("display","block");

                                    $(".liftGateSection").css("display", "none");
                                    document.getElementById("Lift Get Required").checked = false;
                                    $('#ShippingRequirementsMsg').hide();
                                }
                                else{
                                    $(".ShipingmethodMsg").html("");
                                    $(".ShipingmethodMsg").css("display","none");

                                    $(".liftGateSection").css("display", "none");
                                    document.getElementById("Lift Get Required").checked = false;
                                    $('#ShippingRequirementsMsg').hide();
                                }
                            }
                    }else{
                        $(".ShipingmethodMsg").html("");
                                $(".ShipingmethodMsg").css("display","none");
                                $(".StandardShipingmethodMsg").css("display","none");
                                $(".StandardShipingmethodMsg").html("");
                        $('#emgncyShippingPriorityDiv').css('display','none');
                        let selectList = document.getElementById('COshippingmethod');
                        selectList.length = 0;
                        let newOption = document.createElement("option");
                        newOption.text = 'Please select a priority first';
                        newOption.value = '';
                        newOption.selected = true;
                        selectList.appendChild(newOption);
                    }

                });
            } else{
                CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM',
                            severity : 'ERROR',
                            message : 'Error in retrieving warehouse data',
                            classToAppend : 'messagingSection-Warning'
                        }
                    ]
                });
            }
        }
    }
    function initCheckOut(){
        let errorOnPage = false;
        let emptyFields = '';
        let poInputVal = $('#COPurchaseOrderNumber').val();
        var requestShipDateReq = $('#RequestShipdate').val();
        $('.messagingSection-Error').empty();
        $('.messagingSection-Error').removeClass('validationSection-Error');
        $('.messagingSection-Error').hide();

        //update cart
        let comment =  $('#COcomments').val();
        let shippingmethod = $('#COshippingmethod').val();
        let shippingmethodname = $('#COshippingmethod  option:selected').text();
        let warehousevalue = $('#COwarehouse').val();       //this is shipping priority
        let warehouselabel = $('#COwarehouse option:selected').text();
        let incoterms = document.getElementById('icoterms').innerText;      //not required
        let shippingterms = document.getElementById('freightTerms').innerText;      //not required
        let liftGate = document.getElementById("Lift Get Required").checked;
        let requestShipdate = $('#RequestShipdate').val();
        let reqData ={};
        if(CCRZ.currentCart.attributes.sfid){
            reqData.cartId = CCRZ.currentCart.attributes.sfid;
        }
        else{
            reqData.cartId = CCRZ.pagevars.currentCartID;
        }
        reqData.comment  = comment;
        reqData.purchase_order_no  = poInputVal;
        reqData.shippingmethod = shippingmethod;
        reqData.shippingmethodname = shippingmethodname;
        reqData.liftGate = liftGate;
        reqData.requestShipdate = requestShipdate;
        reqData.incoterms = incoterms;
        reqData.shippingterms = shippingterms;
        if(warehousevalue){
            reqData.warehousevalue = warehousevalue;
            reqData.warehouselabel = warehouselabel;
            $('#COwarehouse').removeClass('poNumberBgBorderError').addClass('poNumberBgBorder');
        }else{
            /*CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM',
                        severity : 'ERROR',
                        message : 'Please select a Shipping Priority.',
                        classToAppend : 'messagingSection-Warning'
                    }
                ]
            });*/
            //$('.messagingSection-Error').append('<div class="alert" style="font-weight: 600; color: white;font-size: 17px;">Please select a Shipping Priority.</div>' );
            $('#COwarehouse').removeClass('poNumberBgBorder').addClass('poNumberBgBorderError');
            errorOnPage = true;
            emptyFields = 'Shipping priority';
            //return;
        }

        if(!requestShipDateReq){
            //$('.messagingSection-Error').append('<div class="alert" style="font-weight: 600; color: white;font-size: 17px;">' + CCRZ.pagevars.pageLabels['OXB2B_RequestShipDateRequired'] +'</div>' );
            $('#RequestShipdate').removeClass('poNumberBgBorder').addClass('poNumberBgBorderError');
            errorOnPage = true;
            if(emptyFields==''){
                emptyFields = 'Request Ship Date';
            }else{
                emptyFields = emptyFields + ', Request Ship Date';
            }
            //return;
        }else{
            $('#RequestShipdate').removeClass('poNumberBgBorderError').addClass('poNumberBgBorder');
        }

        if(poInputVal==null || poInputVal===''){

            //$('.messagingSection-Error').append('<div class="alert" style="font-weight: 600; color: white;font-size: 17px;">' + CCRZ.pagevars.pageLabels['OXB2B_Po_Warning'] +'</div>' );
            $('#COPurchaseOrderNumber').removeClass('poNumberBgBorder').addClass('poNumberBgBorderError');
            errorOnPage = true;
            if(emptyFields==''){
                emptyFields = 'Your PO #';
            }else{
                emptyFields = emptyFields + ', Your PO #';
            }
            //return;
        }else{
            $('#COPurchaseOrderNumber').removeClass('poNumberBgBorderError').addClass('poNumberBgBorder');
        }
        let errorOnTerms = false;
        let isEmgncyShipping = $("#emgncyShippingPriorityDiv").is(":visible");
        console.log('isEmgncyShipping:'+isEmgncyShipping);
        debugger;
        if(isEmgncyShipping){
            if(!document.getElementById("termsEmgncyShipPriorityCheckbox").checked){
                $('#termsEmgncyShipPriorityCheckbox').css({"color":"red","outline-color":"red","outline-style": "auto"});
                errorOnPage = true;
                if(emptyFields==''){
                    emptyFields = 'T&C Acceptance for expedited shipping';
                }else{
                    emptyFields = emptyFields + ', T&C Acceptance for expedited shipping';
                }
            }else{
                $('#termsEmgncyShipPriorityCheckbox').css({"color":"black","outline-color":"black","outline-style": "none"});
            }
        }
        if(!document.getElementById("termsConditionsCheckbox").checked){
            //$('#termsWarning').show();
            $('#termsConditionsCheckbox').css({"color":"red","outline-color":"red","outline-style": "auto"});
            errorOnPage = true;
            if(emptyFields==''){
                emptyFields = 'T&C Acceptance';
            }else{
                emptyFields = emptyFields + ', T&C Acceptance';
            }
        }else{
            $('#termsConditionsCheckbox').css({"color":"black","outline-color":"black","outline-style": "none"});
            //$('#termsWarning').hide();
        }
        if(errorOnPage){
            $('.messagingSection-Error').append('<div class="alert" style="font-weight: 600; color: white;font-size: 17px;">Please provide the value(s) to the following fields: '+emptyFields+ '.</div>' );
            $('.messagingSection-Error').addClass('validationSection-Error');
            $('.messagingSection-Error').show();
            window.scrollTo(0,0);
            return;
        }
        //buyer info
        reqData.buyerEmail = CCRZ.cartCheckoutModel.attributes.buyerEmail;
        reqData.buyerFirstName = CCRZ.cartCheckoutModel.attributes.buyerFirstName;
        reqData.buyerLastName = CCRZ.cartCheckoutModel.attributes.buyerLastName;
        reqData.buyerPhone = CCRZ.cartCheckoutModel.attributes.buyerPhone;

        reqData["billingAddress"] = CCRZ.cartCheckoutModel.attributes.billingAddress;
        reqData["shippingAddress"] = CCRZ.cartCheckoutModel.attributes.shippingAddress;

        reqData["billingAddress"].addressList = {};
        reqData["billingAddress"].countryList = {};

        reqData["shippingAddress"].addressList = {};
        reqData["shippingAddress"].countryList = {};

        var javascriptLibrary = 'orderReview';//API JS
        var apexClassName= 'OXB2B_CheckoutController';
        var apexMethods = ['populateShippingDetails'];
        //Initializing JS Remoting Library from Apex Class
        util.initializeVisualforceRemoting(javascriptLibrary , apexClassName ,  apexMethods);

        CCRZ.subsc.orderReview.populateShippingDetails(JSON.stringify(reqData) , function(resp,event){
            if(resp && resp.success ){
                CCRZ.pubSub.trigger("action:processPayment", {"accountNumber":poInputVal, "accountType":"po"});
            }else{
                CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM',
                            severity : 'ERROR',
                            message : 'Error in populating Shipping Details.',
                            classToAppend : 'messagingSection-Warning'
                        }
                    ]
                });
            }
        });

    }

    function populateShippingMethods()
    {
        let shippingMethodRaw = CCRZ.pagevars.pageLabels.TKB2B_Shipping_Methods;
        let shippingMethod = shippingMethodRaw.split(';');

            if (document.getElementById('COshippingmethod') && shippingMethod.length > 0) {
                let selectList = document.getElementById('COshippingmethod');
                let newOption = document.createElement("option");
                newOption.text = shippingMethod[0]; //+' ('+Math.trunc(uoms[i].Factor)+')';
                newOption.value = shippingMethod[0];
                newOption.selected = true;
                selectList.appendChild(newOption);
                for (let i = 1; i < shippingMethod.length; i++) {
                    let newOption = document.createElement("option");
                    newOption.text = shippingMethod[i]; //+' ('+Math.trunc(uoms[i].Factor)+')';
                    newOption.value = shippingMethod[i];
                    selectList.appendChild(newOption);
                }
            }
    }


    function populateOrderReviewConfig(resp ,event){
        if(resp && resp.data)
        {
            var isPoRequired = resp.data.isPoRequired;
            var isCreditCardRequired = resp.data.isCreditCardRequired;
            var addCmtLimit = resp.data.addCommentLimit;
            let allowCreditCardCheckout = checkCreditCardAllowed(resp.data);
            if(allowCreditCardCheckout){
                if(isCreditCardRequired){
                    $('#vrtPayMethodId option[value="po"]').remove();
                    $('.hideCCBtn').show();
                    $('.showPoBtn').hide();
                }
            }else{
                CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM',
                        severity : 'WARN',
                        message : CCRZ.pagevars.pageLabels['VRTB2B_PayrocDown'],
                        classToAppend : 'messagingSection-Warning'
                        }
                    ]
                });
                $('#vrtPayMethodId option[value="cc"]').remove();
                $('.hideCCBtn').hide();
            }
            
            $( "#vrtSubmitOrderPO" ).on('click',function() {
                initPOCheckOut(isPoRequired,isCreditCardRequired);
            });
            $( "#vrtSubmitOrderCC" ).on('click',function() {
                initCCCheckOut(isPoRequired,isCreditCardRequired);
            });  
            $("#addComments").attr('maxlength',addCmtLimit);
            
        }
    }
    function checkCreditCardAllowed(dataMap){
        var allowCreditCardCheckout = true;
        if(dataMap.hasOwnProperty('allowCreditCardCheckout')){
            allowCreditCardCheckout = dataMap.allowCreditCardCheckout;
        }
        if(CCRZ.cartCheckoutModel.attributes){
            if(CCRZ.cartCheckoutModel.attributes.totalAmount == 0){
                allowCreditCardCheckout = false;
            }
            let cItems = CCRZ.cartCheckoutModel.attributes.cartItems ;
            if(cItems && cItems!=null){
                $(cItems).each(function(index,ele){
                    if(ele.itemTotal==0){
                        allowCreditCardCheckout = false;
                        return;
                    }
                });
            }
        }
        return allowCreditCardCheckout;
    }

    //Response Call back method
    function populateDeliveryDate(resp ,event)
    {
        if(resp && resp.data && resp.data.deliveryDays)
        {
            let dates = resp.data.deliveryDays;
            if(!dates.includes(true)){
                dates = [true, true, true, true, true, false, false];
            }
            //beforeShowDayGenerator is a function that returns a function and stores it in beforeShowDayFunction variable
            const beforeShowDayFunction = function beforeShowDayGenerator(dates) {
                return function (date) {
                    //td 0 = sunday, 1 = monday etc
                    let td = date.getDay();
                    if (td === 0) {
                        td = 6;
                    } else {
                        td = td - 1;
                    }
                    return [dates[td], ''];
                }
            }(dates);

            $("#datepicker").datepicker({
                minDate: new Date(),
                beforeShowDay: beforeShowDayFunction
            });
            if(CCRZ.cartCheckoutModel.attributes.hasOwnProperty('requestedDate')){
                let reqdateValue = CCRZ.cartCheckoutModel.attributes['requestedDate'];
                if(typeof reqdateValue !='undefined' && reqdateValue!= null && reqdateValue!==''){
                    //getting local time versus GMT/UTC time difference in minutes
                    var timeDifference = new Date().getTimezoneOffset();
                    reqdateValue = reqdateValue + Math.abs(timeDifference)*60*1000;

                    let tempDate = new Date(reqdateValue);
                    var format = 'mm/dd/yy';

                    resp.data.deliveryDate = $.datepicker.formatDate(format, tempDate);
                }
            }else if(CCRZ.cartCheckoutModel.attributes.hasOwnProperty('requestedDateStr')){
                let reqdateValueStr = CCRZ.cartCheckoutModel.attributes['requestedDateStr'];
                if(reqdateValueStr!= null && reqdateValueStr!=''){
                    resp.data.deliveryDate = reqdateValueStr;
                }
                
            }

            if(resp.data.deliveryDate)
            {
                $('#datepicker').val(resp.data.deliveryDate);
            }
            
        }
    }
    function bindPaymentMethod()
    {
        $( "#vrtPayMethodId" ).change(function() {
            var selectedPayMethod = $( "#vrtPayMethodId option:selected" ).val();
            if(selectedPayMethod==='po'){
                $('.hideCCBtn').hide();
                $('.showPoBtn').show();
            }else if(selectedPayMethod==='cc'){
                $('.hideCCBtn').show();
                $('.showPoBtn').hide();
            }
        });
        $( "#addCommentId" ).on('click',function() {
            $('#addComments').toggle();
        });
    }
    function initPOCheckOut(isPoRequired){
        let poInputVal = $('#poNumber').val();

        if(/\s/.test(poInputVal) || poInputVal.length>12){
            CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM',
                        severity : 'WARN',
                        message : CCRZ.pagevars.pageLabels['VRTB2B_Po_Validation'],
                        classToAppend : 'messagingSection-Warning'
                    }
                ]
            });
            return;                  
        }
        if(poInputVal==null || poInputVal===''){
            if(isPoRequired){
                //show alert
                CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM',
                            severity : 'WARN',
                            message : CCRZ.pagevars.pageLabels['VRTB2B_Po_Warning'],
                            classToAppend : 'messagingSection-Warning'
                        }
                    ]
                });
                return;
            }
        }
        populateShippingDetails('po',poInputVal);

    }

    function initCCCheckOut(isPoRequired){
        let poInputVal = $('#poNumber').val();

        if(poInputVal==null || poInputVal===''){
            if(isPoRequired){
                //show alert
                CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM',
                            severity : 'WARN',
                            message : CCRZ.pagevars.pageLabels['VRTB2B_Po_Warning'],
                            classToAppend : 'messagingSection-Warning'
                        }
                    ]
                });
                return;
            }
        }

        if(!(poInputVal==null || poInputVal==='')){
            if(/\s/.test(poInputVal) || poInputVal.length>12){
                CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM',
                            severity : 'WARN',
                            message : CCRZ.pagevars.pageLabels['VRTB2B_Po_Validation'],
                            classToAppend : 'messagingSection-Warning'
                        }
                    ]
                });
                return;
            }else{
                CCRZ.setCookieWithPath('apex__poNumber' , poInputVal  , 1 , '/');
            }
        }

        populateShippingDetails('cc', poInputVal);
    }

    function populateShippingDetails(payType,poVal){
        let shipdate  = $('#datepicker').val();
        let comment =  $('#addComments').val();
        let reqData ={};
        if(CCRZ.currentCart.attributes.sfid)
        {
            reqData.cartId = CCRZ.currentCart.attributes.sfid;
        }
        else
        {
            reqData.cartId = CCRZ.pagevars.currentCartID;
        }
        reqData.shipdate  = shipdate;
        reqData.comment  = comment;
        reqData.purchase_order_no  = poVal;

        var javascriptLibrary = 'orderReview';//API JS
        var apexClassName= 'VRTB2B_OrderReviewController';
        var apexMethods = ['retrieveDeliveryDate','isPOAllowed','populateShippingDetails'];
        //Initializing JS Remoting Library from Apex Class
        util.initializeVisualforceRemoting(javascriptLibrary , apexClassName ,  apexMethods);

        CCRZ.subsc.orderReview.populateShippingDetails(JSON.stringify(reqData) , function(resp,event){
            if(resp && resp.success ){
                CCRZ.cartCheckoutModel.attributes['note'] = comment;
                CCRZ.cartCheckoutModel.attributes['requestedDateStr'] = shipdate;
                if(shipdate!=''){
                    let newDate = new Date(shipdate);
                    if(newDate){
                        CCRZ.cartCheckoutModel.attributes['requestedDate'] = Date.parse(newDate);
                    }
                }

                if(payType==='po'){
                    handlePOCheckout(poVal);
                }else if(payType==='cc'){
                    handleCCCheckout();
                }
            }else{
                CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM',
                            severity : 'ERROR',
                            message : CCRZ.pagevars.pageLabels['VRTB2B_ShippingDetail_Error'],
                            classToAppend : 'messagingSection-Warning'
                        }
                    ]
                });
            }
        });
    }
    function handleCCCheckout(){
        CCRZ.cartCheckoutView.slideRight();
    }
    function handlePOCheckout(poVal){
        CCRZ.pubSub.trigger("action:processPayment", {"accountNumber":poVal, "accountType":"po"});
        //CCRZ.cartCheckoutView.slideRight();
    }
    function updateShippingAddressValues(){

        let shipping = document.getElementsByName("editShippingAddress");

        let shippingAddress = CCRZ.cartCheckoutModel.attributes.shippingAddress;

        for(var i=0;i < shipping.length;i++){

            if(shipping[i].lang){

                if(shipping[i].lang == 'firstName'){
                    shippingAddress.firstName = shipping[i].value;
                }
                else if(shipping[i].lang == 'lastName'){
                    shippingAddress.lastName = shipping[i].value;
                }
                else if(shipping[i].lang == 'address1'){
                    shippingAddress.address1 = shipping[i].value;
                }
                else if(shipping[i].lang == 'city'){
                    shippingAddress.city = shipping[i].value;
                }
                else if(shipping[i].lang == 'state'){
                    shippingAddress.state = shipping[i].value;
                }
                else if(shipping[i].lang == 'postalCode'){
                    shippingAddress.postalCode = shipping[i].value;
                }


            }

        }

        CCRZ.cartCheckoutModel.attributes.shippingAddress = shippingAddress;

        setVisibleAddressInfo(shippingAddress,1);

        $('#COShippingEditModal .close').click();

    }
});